设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 205|回复: 2

[工具] 分享一个快速绘制水管弯头的工具

[复制链接]
发表于 2020-12-6 23:28:25 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
分享一个快速绘制水管弯头的工具,适用于带中线的双线管道,可以自定义半径曲率,分长半径和短半径两种。用于画水管图很方便!


  1. ;**用于双线表示的管道长弯头的画法,
  2. ;;;方法:两点确定管道直径DN,依次由内往外点击弯头内圆。
  3. ;                   HoonsyBai
  4. ;双线弯头
  5. (defun c:ww( )
  6.   (print "Create by HoonsyBai" )
  7.   (vl-load-com)
  8.   (setvar "cmdecho" 0)
  9.   (setq #lay (getvar "clayer")) ;;取得当前图层
  10.   (setq #os (getvar "osmode"))
  11. (initget "W E")
  12. (setq #k
  13.     (getkword "\n请选择弯头类型:[长半径弯头(W)/短半径弯头(E)]")
  14. )
  15. (if (= #k nil) (setq #k "W"))
  16. (if *D* (setq ds (getdist  (strcat "测量管道直径或输入:<" (rtos *D* 2 2) ">:")))
  17.       (setq ds (getdist "测量管道直径或输入:"))
  18.     )
  19.   (if (null ds) (setq ds *D*) (setq *D* ds))

  20. (princ ds)
  21. (cond ((= #k "W") (progn (setq ds1 ds) (setq ds2 (* ds 1.5)) (setq ds3 (* ds 2))))
  22.       ((= #k "E") (progn (setq ds1 (* ds 0.5)) (setq ds2 ds) (setq ds3 (* ds 1.5))))
  23. )
  24.   (command "fillet" "r" (rtos ds1))
  25.   (command "fillet" (setq e1(sqx)) (setq e2(sqx)))    ;画内倒圆角
  26.   (setq yh(entget(entlast)))
  27.   (command "fillet" "r" (rtos ds2))
  28.   (command "fillet" (sqx) (sqx))    ;画中倒圆角
  29.   (command "fillet" "r" (rtos ds3))
  30.   (command "fillet" (setq e3(sqx)) (setq e4(sqx)))    ;画外倒圆角
  31.   (setq ly (cdr (assoc 8 (entget (car e4)))))

  32.   (setvar "osmode" 0)
  33.   (setvar "clayer" ly)
  34.   (setq pc (cdr (assoc 10 yh))) ;获取圆弧的圆心点  
  35.   (setq pt1 (vlax-curve-getclosestpointto (car e1) pc t))
  36.   (setq pt2 (vlax-curve-getclosestpointto (car e2) pc t))
  37.   (setq pt3 (vlax-curve-getclosestpointto (car e3) pc t))
  38.   (setq pt4 (vlax-curve-getclosestpointto (car e4) pc t)) ;获得圆心到所选取直线的垂足点
  39.   (if (< (abs (- ds (distance pt1 pt3))) 1) (setq ptt1 pt3 ptt2 pt4) (setq ptt1 pt4 ptt2 pt3))
  40.   (setvar "osmode" 0)
  41.   (command "line" pt1 ptt1 "")
  42.   (command "line" pt2 ptt2 "")
  43.   (setvar "osmode" #os)
  44.   (setvar "clayer" #lay)
  45.   (princ)                                 ;静默退出
  46. )


  47. (defun sqx()
  48.   (setq ent nil)
  49.   (while (= ent nil)
  50.    (setq ent (entsel "\n 输入边:"))
  51.   )
  52. )


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 5339个

财富等级: 富甲天下

发表于 2020-12-7 18:01:18 | 显示全部楼层
谢谢楼主的分享,楼主辛苦了
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 630个

财富等级: 财运亨通

发表于 2020-12-8 08:14:03 | 显示全部楼层
生产力工具,谢谢
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2021-2-28 06:34 , Processed in 0.049364 second(s), 18 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表